//+------------------------------------------------------------------+
//| WK MN DY LINES.mq4                                               |
//| Simpler than it looked :)   codobro                              |
//| Alert stuff/opportunity to change colors etc., by fxdaytrader    |
//+------------------------------------------------------------------+
#property copyright "WK NM DY LINES, c 2008 codobro"
#property link "http://forexBaron.net"
#property indicator_chart_window

extern bool DisplayDaily=true;
extern bool DisplayWeekly=true;
extern bool DisplayMonthly=true;

extern color DailyColor=Yellow;
extern int   DailyStyle=STYLE_SOLID;
extern color WeeklyColor=SteelBlue;
extern int   WeeklyStyle=STYLE_SOLID;
extern color MonthlyColor=Orange;
extern int   MonthlyStyle=STYLE_SOLID;

//alerts/misc, fxdaytrader:
extern string gh="alert types:";
extern bool HighLineAlerts=true;
extern bool LowLineAlerts=true;
extern string gh1="for what? d1, w1, mn1?";
extern bool DailyAlerts=true;
extern bool WeeklyAlerts=true;
extern bool MonthlyAlerts=true;
extern string sph="space if D,M,W have the same values?";
extern bool spaceIfSame=true;

extern string ahi="******* ALERT SETTINGS:";
extern int    AlertCandle            = 0;//0:current, 1:last bar, etc.
extern bool   PopupAlerts            = true;
extern bool   EmailAlerts            = false;
extern bool   PushNotificationAlerts = false;
extern bool   SoundAlerts            = false;
extern string SoundFileHigh          = "alert.wav";
extern string SoundFileLow           = "alert2.wav";
double objprice;
//end alerts/misc

//object prefixes:
string D1HighPrefix  = "Daily_Line_High";
string D1LowPrefix   = "Daily_Line_Low";
string W1HighPrefix  = "Weekly_Line_High";
string W1LowPrefix   = "Weekly_Line_Low";
string MN1HighPrefix = "Monthly_Line_High";
string MN1LowPrefix  = "Monthly_Line_Low";

double Weekly[][6];
double Monthly[][6];
double Daily[][6];

double W1H;
double W1L;
double MNH;
double MNL;
double D1H;
double D1L;
//+--------
int init() {
   return(0);
   }

//+----
int deinit() {

   if (DisplayWeekly) { ObjectDelete(W1HighPrefix); ObjectDelete(W1LowPrefix); }
   if (DisplayMonthly) { ObjectDelete(MN1HighPrefix); ObjectDelete(MN1LowPrefix); }
   if (DisplayDaily) { ObjectDelete(D1HighPrefix); ObjectDelete(D1LowPrefix); }

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   int shift;//i

   for (shift=300-1; shift>=0; shift--)

//daily:
      ArrayCopyRates(Daily, Symbol(), 1440);

      D1H = Daily[0][3];
      D1L = Daily[0][2];

      if (DisplayDaily) {
       ObjCreateMove(D1HighPrefix,DailyStyle,DailyColor,D1H);
       ObjCreateMove(D1LowPrefix,DailyStyle,DailyColor,D1L);
      }

//weekly:
      ArrayCopyRates(Weekly, Symbol(), 10080);          

      W1H = Weekly[0][3];
      W1L = Weekly[0][2];
      
      if (spaceIfSame) {
       if (W1H==D1H) W1H=W1H+2*Point;
       if (W1L==D1L) W1L=W1L-2*Point;
      }
      
      if (DisplayWeekly) {
       ObjCreateMove(W1HighPrefix,WeeklyStyle,WeeklyColor,W1H);
       ObjCreateMove(W1LowPrefix,WeeklyStyle,WeeklyColor,W1L);
      }

//monthly:
      ArrayCopyRates(Monthly, Symbol(), 43200);

      MNH = Monthly[0][3];
      MNL = Monthly[0][2];

      if (spaceIfSame) {
       if (MNH==D1H) MNH=MNH+4*Point;
       if (MNL==D1L) MNL=MNL-4*Point;
      }

      if (DisplayMonthly) {
       ObjCreateMove(MN1HighPrefix,MonthlyStyle,MonthlyColor,MNH);
       ObjCreateMove(MN1LowPrefix,MonthlyStyle,MonthlyColor,MNL);
      }

 CheckForLineTouches();//alert stuff
 
 return(0);
   
}
//+------------------------------------------------------------------+ 

void ObjCreateMove(string objname,int objstyle,color objcolor,double price) {
 if(ObjectFind(objname) != 0)
  {
    ObjectCreate(objname,OBJ_HLINE,0, TimeCurrent(),price);
    ObjectSet(objname,OBJPROP_COLOR,objcolor);
    ObjectSet(objname,OBJPROP_STYLE,objstyle);
  }
 else ObjectMove(objname,0,TimeCurrent(),price);
}
//////////////////////////////////////////////////////////////////////
//stuff by fxdaytrader:
double GetObjectPrice(string objname,int objshift) {
 return(ObjectGet(objname,objshift));
}//double GetObjectPrice(string objname,int objshift) {

bool ObjTouched(string objname,int shift) {
  objprice=GetObjectPrice(objname,1);
  if (iHigh(NULL,0,shift)>=objprice && iClose(NULL,0,shift+1)<=objprice) return(true);
    if (iLow(NULL,0,shift)<=objprice && iClose(NULL,0,shift+1)>=objprice) return(true);
 return(false);
}//bool ObjTouched(string objname,int shift) {

void CheckForLineTouches() {
 int lastAlertType=3;
 
  string msg="WK MN DY Lines Alert on "+Symbol()+", period "+TFtoStr(Period())+": "; 

  if (DailyAlerts && DisplayDaily) {
   if (lastAlertType!=2 && HighLineAlerts && ObjTouched(D1HighPrefix,AlertCandle)) {
    msg=msg+"D1 High LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileHigh);
    lastAlertType=2;
   }
   if (lastAlertType!=1 && LowLineAlerts && ObjTouched(D1LowPrefix,AlertCandle)) {
    msg=msg+"D1 Low LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileLow);
    lastAlertType=1;
   }
  }//if (DailyAlerts && DisplayDaily) {

  if (WeeklyAlerts && DisplayWeekly) {
   if (lastAlertType!=2 && HighLineAlerts && ObjTouched(W1HighPrefix,AlertCandle)) {
    msg=msg+"Weekly High LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileHigh);
    lastAlertType=2;
   }
   if (lastAlertType!=1 && LowLineAlerts && ObjTouched(W1LowPrefix,AlertCandle)) {
    msg=msg+"Weekly Low LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileLow);
    lastAlertType=1;
   }
  }//if (WeeklyAlerts && DisplayWeekly) {
 
  if (MonthlyAlerts && DisplayMonthly) {
   if (lastAlertType!=2 && HighLineAlerts && ObjTouched(MN1HighPrefix,AlertCandle)) {
    msg=msg+"Monthly High LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileHigh);
    lastAlertType=2;
   }
   if (lastAlertType!=1 && LowLineAlerts && ObjTouched(MN1LowPrefix,AlertCandle)) {
    msg=msg+"Monthly Low LINE HIT @ "+DoubleToStr(objprice,Digits);
    doAlerts(msg,SoundFileLow);
    lastAlertType=1;
   }
  }//if (MonthlyAlerts && DisplayMonthly) {

}//void CheckForLineTouch() {

void doAlerts(string msg,string SoundFile) {
 static datetime lastAlertTime=0;
 if (lastAlertTime!=iTime(NULL,0,0)) {
  lastAlertTime=iTime(NULL,0,0);

 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (PopupAlerts) Alert(msg);
  if (EmailAlerts) SendMail(emailsubject,msg);
  if (PushNotificationAlerts) SendNotification(msg);
  if (SoundAlerts) PlaySound(SoundFile);

 }//if (lastAlertTime!=iTime(NULL,0,0)) {
 
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {
//end stuff by fxdaytrader
//////////////////////////////////////////////////////////////////////